/* copyright  by Stefan Voitel, 2003 - all rights reserved                   */
/* eMail : stefan.voitel@winways.de                                           */
/* Implements a sipmple cicular buffer                                        */


#ifndef __CLASS_QUEUE_INCLUDED__
#define __CLASS_QUEUE_INCLUDED__

class cQueue {
  public:

   cQueue () : Reader(0),Writer(0),Size (sizeof(List)/sizeof(List[0])) {
      memset (&List,0,sizeof(List));
      }

   // Push gets public;
   bool AddCommand (char *cmd) {
      return Push (cmd);
      }

 protected:
 
   // push a char* to queue
   bool  Push     (char *cmd) {
      bool  success = false;
      int   lenght  = (int) strlen (cmd);

      if ((List[Writer]  = new char[lenght +1]) != NULL) {
         memset (List[Writer],0,lenght);
         strcpy (List[Writer],cmd);
         success = true;
         }

      if (Size <= ++Writer)
         Writer = 0;
      return success;
      }

   // remove a char* from queue
   void  Pop      (void) {
      delete[] List[Reader];
      List[Reader] = NULL;

      if (Size <= ++Reader)
         Reader = 0;
      }

   // get a value from queue
   char* Get      (void) {
      return Writer != Reader ? List[Reader] : NULL;
      }

   // false is a value avaliable
   bool  IsEmpty  (void) {
      return Reader == Writer;
      }

  private:
   char       *List[1024];
   int         Writer;        // tail
   int         Reader;        // head
   int         Size;          // queue lenght
};
#endif //  __CLASS_QUEUE_INCLUDED__
// EOF 